<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="大哥的display_id" prop="displayId">
        <el-input v-model="formData.displayId" placeholder="请输入大哥的display_id" />
      </el-form-item>
      <el-form-item label="大哥的用户id" prop="userIdStr">
        <el-input v-model="formData.userIdStr" placeholder="请输入大哥的用户id" />
      </el-form-item>
      <el-form-item label="大哥的用户昵称" prop="nickname">
        <el-input v-model="formData.nickname" placeholder="请输入大哥的用户昵称" />
      </el-form-item>
      <el-form-item label="大哥的等级" prop="level">
        <el-input v-model="formData.level" placeholder="请输入大哥的等级" />
      </el-form-item>
      <el-form-item label="大哥打赏的金币" prop="hostcoins">
        <el-input v-model="formData.hostcoins" placeholder="请输入大哥打赏的金币" />
      </el-form-item>
      <el-form-item label="大哥的粉丝数" prop="followerCount">
        <el-input v-model="formData.followerCount" placeholder="请输入大哥的粉丝数" />
      </el-form-item>
      <el-form-item label="大哥的关注数" prop="followingCount">
        <el-input v-model="formData.followingCount" placeholder="请输入大哥的关注数" />
      </el-form-item>
      <el-form-item label="大哥所在的地区" prop="region">
        <el-input v-model="formData.region" placeholder="请输入大哥所在的地区" />
      </el-form-item>
      <el-form-item label="大哥打赏的历史最高金币" prop="historicHighCoins">
        <el-input v-model="formData.historicHighCoins" placeholder="请输入大哥打赏的历史最高金币" />
      </el-form-item>
      <el-form-item label="大哥历史打赏金币总和" prop="totalGiftCoins">
        <el-input v-model="formData.totalGiftCoins" placeholder="请输入大哥历史打赏金币总和" />
      </el-form-item>
      <el-form-item label="大哥所在的直播间的主播display_id" prop="hostDisplayId">
        <el-input v-model="formData.hostDisplayId" placeholder="请输入大哥所在的直播间的主播display_id" />
      </el-form-item>
      <el-form-item label="该数据所属的账号id" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入该数据所属的账号id" />
      </el-form-item>
      <el-form-item label="是否洽谈" prop="operationStatus">
        <el-radio-group v-model="formData.operationStatus">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { EmployeeBigBrotherApi, EmployeeBigBrotherVO } from '@/api/server/employeebigbrother'

/** 大哥数据员工业务 表单 */
defineOptions({ name: 'EmployeeBigBrotherForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  displayId: undefined,
  userIdStr: undefined,
  nickname: undefined,
  level: undefined,
  hostcoins: undefined,
  followerCount: undefined,
  followingCount: undefined,
  region: undefined,
  historicHighCoins: undefined,
  totalGiftCoins: undefined,
  hostDisplayId: undefined,
  userId: undefined,
  operationStatus: undefined
})
const formRules = reactive({
  displayId: [{ required: true, message: '大哥的display_id不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EmployeeBigBrotherApi.getEmployeeBigBrother(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EmployeeBigBrotherVO
    if (formType.value === 'create') {
      await EmployeeBigBrotherApi.createEmployeeBigBrother(data)
      message.success(t('common.createSuccess'))
    } else {
      await EmployeeBigBrotherApi.updateEmployeeBigBrother(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    displayId: undefined,
    userIdStr: undefined,
    nickname: undefined,
    level: undefined,
    hostcoins: undefined,
    followerCount: undefined,
    followingCount: undefined,
    region: undefined,
    historicHighCoins: undefined,
    totalGiftCoins: undefined,
    hostDisplayId: undefined,
    userId: undefined,
    operationStatus: undefined
  }
  formRef.value?.resetFields()
}
</script>